#include <bits/stdc++.h>
using namespace std;

int main() {
    // nacitame vstup
    int N, K, L;
    cin >> N >> K >> L;
    --K; // v programe indexujeme od nuly
    vector<int> tanecnici(N);
    for (int &x : tanecnici) cin >> x;

    // overime, ci existuje riesenie
    vector<int> zaver = tanecnici;
    sort( zaver.begin(), zaver.end() );
    if (zaver[K] != tanecnici[K]) { cout << "NE\n"; return 0; }

    // explicitne priradime kazdemu prvku miesto, kam patri
    vector<int> stav(N, -1);
    stav[K] = K;
    for (int n=0; n<N; ++n) if (n != K) {
        for (int i=0; i<N; ++i) if (tanecnici[i] == zaver[n] && stav[i] == -1) {
            stav[i] = n;
            break;
        }
    }

    // zistime, ktora strana je kratsia, a podla toho si zvolime,
    // od ktoreho konca ideme prvky umiestnovat na spravne miesto
    int start = 0, step = 1, end = N;
    if (K > N-1-K) { start = N-1; step = -1; end = -1; }

    // postupne pre kazde n umiestnime spravny prvok na miesto n
    vector< pair<int,int> > kroky;
    for (int n=start; n!=end; n+=step) {
        if (stav[n] == n) continue; // uz je tam
        int where = 0;
        while (stav[where] != n) ++where;
        if ( (where-K)*(n-K) < 0 ) {
            // prvok mame na nespravnej strane krala
            int mirror = 2*K - n;
            
            int i = min(mirror,where), j=max(mirror,where)+1;
            kroky.push_back( {i, j} );
            reverse( stav.begin()+i, stav.begin()+j );
            
            i = min(mirror,n); j = max(mirror,n)+1;
            kroky.push_back( {i, j} );
            reverse( stav.begin()+i, stav.begin()+j );
        } else {
            // prvok mame na spravnej strane krala
            int i = min(n,where), j = max(n,where)+1;
            kroky.push_back( {i, j} );
            reverse( stav.begin()+i, stav.begin()+j );
        }
    }

    // vypiseme vystup
    cout << "ANO\n";
    if (L == 0) return 0;
    cout << kroky.size() << "\n";
    for (const auto &krok : kroky) cout << (krok.first+1) << " " << krok.second << "\n";
}
